<?php
$LANGUAGE = 'en'; // en: English, fr: French
$INCLUDES = '/\.(gif|jpeg|jpg|png)$/i';
$COMMENT_EXT = '.txt';
$TILTVIEWER_JS = $_SERVER['DOCUMENT_ROOT'] . '/tiltviewer/swfobject.js';
$TILTVIEWER_SWF = $_SERVER['DOCUMENT_ROOT'] . '/tiltviewer/TiltViewer.swf';

$LANGUAGES = array();
$LANGUAGES['en'] = array(
	'galleryof'		=> 'Gallery of ',
	'mtime'			=> 'Last modified: ',
	'ftime'			=> '%Y-%m-%d %H:%M:%S',
	'size'			=> 'Size: ',
	'sizes'			=> array('KiB', 'MiB', 'GiB', 'TiB', 'PiB', 'EiB'),
	'dec'			=> '.',
	'sep'			=> ',',
	'dimensions'	=> 'Dimensions: ',
	'comment'		=> 'Comment: ',
	'view'			=> 'View image',
	'fullscreen'	=> 'Go fullscreen',
	'exit'			=> 'Exit fullscreen',
	'about'			=> 'About',
);
$LANGUAGES['fr'] = array(
	'galleryof'		=> 'Galerie de ',
	'mtime'			=> 'Modifi : ',
	'ftime'			=> '%Y/%m/%d %H:%M:%S',
	'size'			=> 'Taille : ',
	'sizes'			=> array('Kio', 'Mio', 'Gio', 'Tio', 'Pio', 'Eio'),
	'dec'			=> ',',
	'sep'			=> ' ',
	'dimensions'	=> 'Dimensions : ',
	'comment'		=> 'Commentaire : ',
	'view'			=> 'Voir l\'image',
	'fullscreen'	=> 'Plein cran',
	'exit'			=> 'Quitter le plein cran',
	'about'			=> ' propos',
);
$LANG = $LANGUAGES[$LANGUAGE];
$SIZES = $LANG['sizes'];

if (array_key_exists('q', $_GET) && $_GET['q'] == 'js') {

	header('Content-type: text/javascript');
	echo file_get_contents($TILTVIEWER_JS);
	return;

} elseif (array_key_exists('q', $_GET) && $_GET['q'] == 'swf') {

	header('Content-type: application/x-shockwave-flash');
	echo file_get_contents($TILTVIEWER_SWF);
	return;

} elseif (array_key_exists('q', $_GET) && $_GET['q'] == 'xml') {

	function format_size($size) {
		global $LANG;
		global $SIZES;
		$max = count($SIZES) - 1;
		$i = 0;

		$size /= 1024;
		if (0 < $size && $size < 0.1) {
			$size = 0.1;
		} else {
			while ($i < $max && $size > 1024) {
				$size /= 1024;
				$i++;
			}
		}

		return number_format(round($size, 1), 1,
			$LANG['dec'], $LANG['sep']) . $SIZES[$i];
	}

	function get_image_comment($image) {
		$filename = preg_replace('/\.[^.]*$/', '.txt', $image);
		$comment = '';

		if (is_file($filename)) {
			$comment = file_get_contents($filename);
		}

		return $comment;
	}

	function scan_dir($dir) {
		global $LANG;
		global $INCLUDES;
		$files = array();

		if ($dh = opendir($dir)) {
			while (($basename = readdir($dh)) !== false) {
				if (preg_match($INCLUDES, $basename)) {
					$filename = $dir . $basename;
					if (is_file($filename)) {
						$file = array();
						$file['name'] = $basename;
						$file['size'] = format_size(filesize($filename));
						$file['mtime'] = strftime($LANG['ftime'],
							filemtime($filename));
						list($file['width'], $file['height']) =
							getimagesize($filename);
						$file['comment'] = get_image_comment($filename);
						$files[] = $file;
					}
				}
			}
		}

		return $files;
	}

	function gen_xml($files) {
		global $LANG;
		$xml = '<tiltviewergallery><photos>';

		foreach ($files as $file) {
			$xml .= '<photo imageurl="' . $file['name']
				. '" linkurl="' . $file['name'] . '">'
				. '<title>' . $file['name'] . '</title>'
				. '<description><![CDATA['
				. '<b>' . $LANG['size'] . '</b>' . $file['size'] . '<br>'
				. '<b>' . $LANG['mtime'] . '</b>' . $file['mtime'] . '<br>'
				. '<b>' . $LANG['dimensions'] . '</b>' . $file['width']
				. 'x' . $file['height'] . '<br>';
			if (!preg_match('/^\s*$/', $file['comment'])) {
				$xml .= '<b>' . $LANG['comment'] . '</b>'
					. $file['comment'] . '<br>';
			}
			$xml .= ']]></description></photo>';
		}

		return $xml . '</photos></tiltviewergallery>';
	}

	header('Content-type: text/xml');
	$files = scan_dir('./');
	@sort($files);
	echo gen_xml($files);
	return;

} else {

	function scan_max_width($dir) {
		global $INCLUDES;
		$max = 0;

		if ($dh = opendir($dir)) {
			while (($basename = readdir($dh)) != false) {
				if (preg_match($INCLUDES, $basename)) {
					$filename = $dir . $basename;
					if (is_file($filename)) {
						list($width) = getimagesize($filename);
						if ($width > $max) {
							$max = $width;
						}
					}
				}
			}
		}

		return $max;
	}

	$max_width = scan_max_width('./');

}
?>

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<title><?php echo $LANG['galleryof'], dirname($_SERVER['PHP_SELF']) ?></title>
		<script type="text/javascript" src="?q=js"></script>
		<style type="text/css">	
			html {
				height: 100%;
				overflow: hidden;
			}
			body {
				height: 100%;
				margin: 0px;
				padding: 0px;
				background-color: #000000;
				color: #ffffff;
				font-family: sans-serif;
				font-size: 40px;
			}
		</style>
	</head>
	<body>
		<div id="gallery"></div>
		<script type="text/javascript">
			var fo = new SWFObject("?q=swf", "viewer",
				"100%", "100%", "9.0.28", "#000000");			
			fo.addVariable("useFlickr", "false");
			fo.addVariable("xmlURL", "?q=xml");
			fo.addVariable("maxJPGSize","<?php echo $max_width ?>");
			fo.addVariable("useReloadButton", "false");
			fo.addVariable("columns", "5");
			fo.addVariable("rows", "4");
			fo.addVariable("showFlipButton", "true");
			fo.addVariable("showLinkButton", "true");		
			fo.addVariable("linkLabel", "<?php echo $LANG['view'] ?>");
			fo.addVariable("frameColor", "0x000000");
			fo.addVariable("backColor", "0xFFFFFF");
			fo.addVariable("bkgndInnerColor", "0xFFFFFF");
			fo.addVariable("bkgndOuterColor", "0xFFFFFF");				
			fo.addVariable("langGoFull", "<?php echo $LANG['fullscreen'] ?>");
			fo.addVariable("langExitFull", "<?php echo $LANG['exit'] ?>");
			fo.addVariable("langAbout", "<?php echo $LANG['about'] ?>");				
			fo.addParam("allowFullScreen","true");
			fo.write("gallery");			
		</script>	
	</body>
</html>
<!-- $Id: tiltgallery.php,v 1.5 2009/09/09 17:29:51 iekko Exp $ -->

